package org.appfuse.service.impl;

import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.appfuse.dao.UserDAO;
import org.appfuse.model.User;
import org.appfuse.service.UserManager;
import org.springframework.validation.BindException;
import org.springframework.validation.Validator;


public class UserManagerImpl implements UserManager {
    private static Log log = LogFactory.getLog(UserManagerImpl.class);
    private UserDAO dao;
    private Validator validator;

    public void setUserDAO(UserDAO dao) {
        this.dao = dao;
    }

    public void setValidator(Validator validator) {
    	this.validator = validator;
    }
    
    public List getUsers() {
        return dao.getUsers();
    }

    public User getUser(String userId) {
        User user = dao.getUser(Long.valueOf(userId));

        if (user == null) {
            log.warn("UserId '" + userId + "' not found in database.");
        }

        return user;
    }

    public User saveUser(User user) {
        BindException errors = new BindException(user, "user");
        validator.validate(user, errors);
        if (errors.hasErrors()) {
        	throw new RuntimeException("validation failed!", errors);
        }
        dao.saveUser(user);

        return user;
    }

    public void removeUser(String userId) {
        dao.removeUser(Long.valueOf(userId));
    }
}
