package org.appfuse.web;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import junit.framework.TestCase;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.mock.web.MockHttpServletRequest;
import org.springframework.mock.web.MockServletContext;
import org.springframework.web.context.support.XmlWebApplicationContext;
import org.springframework.web.servlet.ModelAndView;

public class UserControllerTest extends TestCase {
    private static Log log = LogFactory.getLog(UserControllerTest.class);
    
    private XmlWebApplicationContext ctx;

    public void setUp() {
        String[] paths = {"/WEB-INF/applicationContext*.xml",
                          "/WEB-INF/action-servlet.xml"};
        ctx = new XmlWebApplicationContext();
        ctx.setConfigLocations(paths);
        ctx.setServletContext(new MockServletContext(""));
        ctx.refresh();
    }

    public void testGetUsers() throws Exception {
        UserController c = (UserController) ctx.getBean("userController");
        ModelAndView mav = c.handleRequest((HttpServletRequest) null,
				           (HttpServletResponse) null);
        Map m = mav.getModel();
        assertNotNull(m.get("users"));
        assertEquals(mav.getViewName(), "userList");
    }
    
    public void testGetUsersAsXML() throws Exception {
        UserController c = (UserController) ctx.getBean("userController");
        MockHttpServletRequest request = new MockHttpServletRequest();
        request.addParameter("report", "XML");
        ModelAndView mav = c.handleRequest(request, (HttpServletResponse) null);
        log.debug("view returned: " + mav.getViewName());
        assertEquals(mav.getViewName(), "userListXML");
    }
}